#ifndef KPSE_INC_H
#define KPSE_INC_H
#ifndef KPSEDLL
#define KPSEDLL __declspec(dllimport)
#endif

typedef enum
{
  kpse_gf_format,
  kpse_pk_format,
  kpse_any_glyph_format,
  kpse_tfm_format, 
  kpse_afm_format, 
  kpse_base_format, 
  kpse_bib_format, 
  kpse_bst_format, 
  kpse_cnf_format,
  kpse_db_format,
  kpse_fmt_format,
  kpse_fontmap_format,
  kpse_mem_format,
  kpse_mf_format, 
  kpse_mfpool_format, 
  kpse_mft_format, 
  kpse_mp_format, 
  kpse_mppool_format, 
  kpse_mpsupport_format,
  kpse_ocp_format,
  kpse_ofm_format, 
  kpse_opl_format,
  kpse_otp_format,
  kpse_ovf_format,
  kpse_ovp_format,
  kpse_pict_format,
  kpse_tex_format,
  kpse_texdoc_format,
  kpse_texpool_format,
  kpse_texsource_format,
  kpse_tex_ps_header_format,
  kpse_troff_font_format,
  kpse_type1_format, 
  kpse_vf_format,
  kpse_dvips_config_format,
  kpse_ist_format,
  kpse_truetype_format,
  kpse_type42_format,
  kpse_web2c_format,
  kpse_program_text_format,
  kpse_program_binary_format,
  kpse_miscfonts_format,
  kpse_web_format,
  kpse_cweb_format,
  kpse_last_format /* one past last index */
} kpse_file_format_type;

typedef enum
{
  kpse_src_implicit,   /* C initialization to zero */
  kpse_src_compile,    /* configure/compile-time default */
  kpse_src_texmf_cnf,  /* texmf.cnf, the kpathsea config file */
  kpse_src_client_cnf, /* application config file, e.g., config.ps */
  kpse_src_env,        /* environment variable */
  kpse_src_x,          /* X Window System resource */
  kpse_src_cmdline     /* command-line option */
} kpse_src_type;

typedef struct
{
  char *type;		/* Human-readable description.  */
  char *path;		/* The search path to use.  */
  char *raw_path;	/* Pre-$~ (but post-default) expansion.  */
  char *path_source;	/* Where the path started from.  */
  char *override_path;	/* From client environment variable.  */
  char *client_path;	/* E.g., from dvips's config.ps.  */
  char *cnf_path;	/* From texmf.cnf.  */
  char *default_path;	/* If all else fails.  */
  char **suffix;		/* For kpse_find_file to check for/append.  */
  char **alt_suffix;	/* More suffixes to check for.  */
  int suffix_search_only;	/* Only search with a suffix?  */
  char *program;		/* ``mktexpk'', etc.  */
  char *program_args;	/* Args to `program'.  */
  int program_enabled_p;	/* Invoke `program'?  */
  kpse_src_type program_enable_level; /* Who said to invoke `program'.  */
  int binmode;              /* The files must be opened in binary mode. */
} kpse_format_info_type;


extern KPSEDLL char *kpse_path_expand(char *f);
extern KPSEDLL char *kpse_find_file(char *name,  
                            kpse_file_format_type format, int must_exist);
extern KPSEDLL char *kpse_program_name;
extern KPSEDLL char *concat(char *s, char *t);
extern KPSEDLL void kpse_set_progname(char *s);
extern KPSEDLL void kpse_reset_program_name(char *s);
extern KPSEDLL void getlongname(char *a);
extern KPSEDLL int isknj(int n);
extern KPSEDLL int isknj2(int n);
#endif
