################################################################################
#
# Makefile  : ChkTeX
# Author    : Fabrice Popineau <Fabrice.Popineau@supelec.fr>
# Platform  : Win32, Microsoft VC++ 6.0, depends upon fpTeX 0.5 sources
# Time-stamp: <02/01/20 23:46:33 popineau>
#
################################################################################
root_srcdir = ..\..
INCLUDE=$(INCLUDE);$(root_srcdir)\win32

USE_KPATHSEA = 1
USE_GNUW32 = 1

!include <make/common.mak>

# We need to get getopt.h from kpathsea, not from the current directory.
DEFS = -I$(kpathseadir) $(DEFS) -D_MSDOS -DHAVE_CONFIG_H 

objects = $(objdir)\ChkTeX.obj $(objdir)\FindErrs.obj $(objdir)\OpSys.obj \
	$(objdir)\Resource.obj $(objdir)\Utility.obj

programs = $(objdir)\ChkTeX.exe

manfiles =
#infofiles = ChkTeX.info
pdfdocfiles = ChkTeX.pdf
htmlfiles =

docdir = $(texmf)\doc\chktex
installdirs = $(bindir) $(texmf)\chktex  $(texmf)\doc\chktex

default: all

all: $(objdir) $(programs)

$(objdir)\ChkTeX.exe: $(objects) $(kpathsealib)
	$(link) $(objects) $(kpathsealib) $(conlibs)

!include <make/config.mak>
!include <make/install.mak>

install:: install-exec install-data install-man install-doc

install-data::
	-@echo $(verbose) & ( \
		echo "Installing data in $(MAKEDIR)" & \
		$(copy) chktexrc $(texmf)\chktex\.chktexrc $(redir_stdout) \
	)

distclean::
	-@$(del) config.h chktex.dvi chktex.pdf

!include <make/clean.mak>
!include <make/rdepend.mak>
!include "./depend.mak"

#
# Local Variables:
# mode: makefile
# End: