/*
 * Copyright (c) Matsushita Electric Industrial Co.,Ltd. 1994
 *
 * $Id: gf.h,v 1.7 1994/03/24 13:19:22 kakiuchi Exp $
 */

#ifndef _GF_
#define _GF_

/* This is a header file for gf font file. */

#include "font.h"

/*
 * gf file constants
 */

#define	NGFCHARS	256
#define	FIRSTGFCHAR	0
#define	LASTGFCHAR	255

/* The following macros describe gf file format */

#define paint_0		0
#define last_paint	63
#define paint1		64
#define paint2		65
#define paint3		66
#define boc		67
#define boc1		68
#define eoc		69
#define skip0		70
#define skip1		71
#define skip2		72
#define skip3		73
#define new_row_0	74
#define last_new_row	238
#define xxx1		239
#define xxx2		240
#define xxx3		241
#define xxx4		242
#define yyy		243
#define no_op		244
#define char_loc	245
#define char_loc0	246
#define pre		247
#define post		248
#define postpost	249
#define undefined_cases	250: case 251: case 252: case 253: case 254: case 255
#define gf_version	131

/*
 * Data Structures
 * ===============
 */

/*
 * Font infomation.
 */

typedef struct font_entry {
  /* common fields (defined in font.h) */
  CommonEntry common;
  /* gf file specific fields */
  struct gf_entry *gf;
} FontEntry;

#include "common.h"

typedef struct gf_entry {
  u32 designsize;
  u32 checksum;
  u32 hppp;
  u32 vppp;
  i32 font_min_m;
  i32 font_max_m;
  i32 font_min_n;
  i32 font_max_n;
  CharEntry ch[NGFCHARS];
} GfEntry;

#endif /* _GF_ */
