/*
fmtutil.c   (2002/10/06 --ak)
Web2C-7.3.9 (2002/10/25 --ak)
Web2C-7.4.2 (2002/12/27 --ak)
Web2C-7.4.3 (2003/01/12 --ak)
Web2C-7.5.2 (2003/11/09 --ak)
Web2C-7.5.3 (2004/05/09 --ak)
Web2C-7.5.3 (2004/06/11 --ak)
Web2C-7.5.5 (2005/12/23 --ak)
Web2C-7.5.5 (2006/11/25 --ak)
*/

#include <kpathsea/kpathsea.h>
#include <malloc.h>
#include <direct.h>
#include <stdlib.h>
#include <windows.h>
#include <io.h>
#include <fcntl.h>

#undef system
#define system win32_system

#define BLEN       256
#define SLEN       128
#define MAXFMT     128
#define SIXTY4     64
#define SIXTEEN    16
#define DEFAULTCNF "fmtutil.cnf"
#define REVISION   "fmtutil (C version 0.3) 2002-2005 --ak"

typedef struct {
char *format;
char *engine;
char *hyphen;
char *args;
} cmd_t;

/*
Global variables
*/
cmd_t K[MAXFMT];
int   Fmtnum = 0;
char  Buff[BLEN];
char  Programname[SIXTY4];
char  Enginename[SIXTY4];
char  Realenginename[SIXTY4];
char  Destdir[BLEN];
char  Currdir[BLEN];
char  *Exefile[MAXFMT];
char  Exenum = 0;
int   Logfile = 0;
int   UserDestdir = 0;

/* check a directory */
int is_dir(char *buff)
{
  HANDLE h;
  WIN32_FIND_DATA w32fd;

  if(((h = FindFirstFile(buff, &w32fd))
      != INVALID_HANDLE_VALUE) &&
     (w32fd.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)) {
    FindClose(h);
    return (1);
  }
  else {
    FindClose(h);
    return (0);
  }
}

/* make a directory */
int make_dir(char *buff)
{
  if(_mkdir(buff)) {
    printf("mkdir error.\n");
    return (1);
  }
  if(_chmod(buff, _S_IREAD | _S_IWRITE)) {
    printf("chmod failed.\n");
    return (1);
  }
  return (0);
}

void
revision(void)
{
  printf(REVISION "\n");
}

void
usage(void)
{
  printf(
"Commands:\n"
" --all                      recreate all format, base, mem files\n"
" --missing                  create all missing format, base, mem files\n"
" --byfmt formatname         (re)create format for `formatname'\n"
"                            `base' and `mem' files can also be created\n"
" --byhyphen hyphenfile      (re)create formats that depend on `hyphenfile'\n"
" --showhyphen formatname    print name of hyphenfile for format `formatname'\n"
" --version                  show revision number\n"
" --help                     show this message\n"
"\n"
"Options:\n"
" --cnffile file             set configfile for fmtutil\n"
"                            default is `fmtutil.cnf'\n"
" --fmtdir directory         set destination directory for format files\n"
"                            `directory' must be an absolute path\n"
"                            default is $TEXMFMAIN/web2c/$engine\n"
" --engine texengine         specify the TeX engine (with --byfmt fmtname).\n"
" --log                      save log file(s) in the TEMP directory\n");
}

void
freeK(void)
{
  int i;
  for(i=0; i < MAXFMT; i++) {
    free(K[i].format);
    free(K[i].engine);
    free(K[i].hyphen);
    free(K[i].args);
    free(Exefile[i]);
  }
}

int
do_initex(char *fm, char *en, char *args)
{
  int  ret;
  char fmt[SIXTY4];
  char ext[SIXTEEN];
  char cmd[BLEN];
  char progn[SIXTY4];
  char progn2[SIXTY4];
  char enginesubdir[SIXTY4];
  char src[SLEN];
  char dst[BLEN];
  char log[SLEN];
  char *p;

  if(!strnicmp(fm, "cont", 4)) strcpy(progn, "context");
  else if(!strnicmp(fm, "ptex-", 5)) strcpy(progn, "ptex");
  else if(!strnicmp(fm, "platex-", 7)) strcpy(progn, "platex");
  else strcpy(progn, fm);

  strcpy(enginesubdir, en);

  if(!stricmp(enginesubdir, "mf-nowin"))
    strcpy(enginesubdir, "metafont");
  if(!stricmp(enginesubdir, "mf"))
    strcpy(enginesubdir, "metafont");
  if(!stricmp(enginesubdir, "mpost"))
    strcpy(enginesubdir, "metapost");
  if(!stricmp(enginesubdir, "jmpost"))
    strcpy(enginesubdir, "jmetapost");

  if(!stricmp(en, "mf-nowin")) {
    strcpy(fmt, "--jobname=");
    strcpy(ext, ".base");
  }
  else if(!stricmp(en, "mf")) {
    strcpy(fmt, "--jobname=");
    strcpy(ext, ".base");
  }
  else if(!stricmp(en, "mpost")) {
    strcpy(fmt, "--jobname=");
    strcpy(ext, ".mem");
  }
  else if(!stricmp(en, "jmpost")) {
    strcpy(fmt, "--jobname=");
    strcpy(ext, ".mem");
  }
  else if(!stricmp(en, "nts")) {
    strcpy(fmt, "--fmt=");
    strcpy(ext, ".nfmt");
  }
  else {
    strcpy(fmt, "--jobname=");
    strcpy(ext, ".fmt");
  }

  if(!stricmp(en, "jmpost") || !stricmp(en, "mpost"))
    strcpy(progn2, "mpost");
  else if(!stricmp(en, "mf-nowin"))
    strcpy(progn2, "mf");
  else if(!stricmp(en, "nts"))
    strcpy(progn2, "tex");
  else strcpy(progn2, progn);

  if(!stricmp(en, "nts"))
    sprintf(cmd, "%s --ini --progname=%s %s <nul",
            en, progn2, args);
  else
    sprintf(cmd, "%s --ini %s%s --progname=%s %s <nul",
            en, fmt, fm, progn2, args);

  printf("Running: %s\n", cmd);
  ret = system(cmd);
  strcpy(src, fm);
  strcpy(log, fm);
  strcat(log, ".log");
  strcat(src, ext);
  strcpy(dst, Destdir);

  if((UserDestdir == 0) && stricmp(enginesubdir, "nts")) {
    strcat(dst, enginesubdir);
    if(!is_dir(dst)) {
      if(make_dir(dst)) {
        printf("mkdir failed.\n");
        return (-100);
      }
    }
    strcat(dst, "/");
  }

  strcat(dst, src);
  if(_access(src, 0) == 0) {
    CopyFile(src, dst, FALSE);
    remove(src);
    if(Logfile == 0) remove(log);
    printf("The file %s%s created.\n", fm, ext);
    if(!strcmp(progn, "context"))
      strcpy(Exefile[Exenum], "texexec");
    else if(!strcmp(en, "nts"))
      strcpy(Exefile[Exenum], "nts");
    else
      strcpy(Exefile[Exenum], fm);

    Exenum++;
  }
  else {
    printf("The file %s%s not created.\n", fm, ext);
    ret = -100;
  }
  return ret;
}

void
do_all(void)
{
  int i;

  for(i = 0; i < Fmtnum; i++)
    do_initex(K[i].format, K[i].engine, K[i].args);
}

void
show_hyphen(char *fm, char *hfile)
{
  char *p;
  char progn[SIXTY4];
  char buffer[BLEN];

  if(!strcmp(hfile, "-")) {
    printf("%s\n", hfile);
    return;
  }

  if(!strnicmp(fm, "cont", 4)) strcpy(progn, "context");
  else strcpy(progn, fm);

  printf("Searching ... \n");
  kpse_reset_program_name(progn);
  p = kpse_find_file(hfile, kpse_tex_format, 0);
  kpse_reset_program_name(Programname);
  if(!p) {
     printf("%s not found.\n", hfile);
     return;
  }
  printf("%s\n", p);
  free(p);
  return;
}

int
testexe(char *name, char *suffix)
{
  char buffer[BLEN];
  char *p;

  if(SearchPath(NULL, name, suffix, BLEN, buffer, &p))
    return 1;
  else
    return 0;
}

int
main(int ac, char **av)
{
  FILE *in;

  int  i, j, k;
  char *cnfname;
  char *p;
  char *q;
  char cnffile[SIXTY4];
  char fmtname[SIXTY4];
  char hyphenfile[SIXTY4];
  char kpsedot[BLEN];
  char enginesubdir[SIXTY4];
  char *tmp;
  int  cdrive, tdrive;

  int  flag;
  
/*
flag = 1 : --all
       2 : --missing
       3 : --byfmt formatname
       4 : --byhyphen hyphenfile
       5 : --showhyphen formatname
*/

  flag = 0;
  cnffile[0] = '\0';
  fmtname[0] = '\0';
  hyphenfile[0] = '\0';
  Destdir[0] = '\0';
  Currdir[0] = '\0';
  Enginename[0] = '\0';
  Realenginename[0] = '\0';

  getlongname(av[0]);
  kpse_set_progname(av[0]);
  strcpy(Programname, av[0]);

  tmp = getenv("TEMP");
  if(!tmp) tmp = getenv("TMP");
  if(!tmp) tmp = getenv("TMPDIR");
  if(!tmp) {
    fprintf(stderr, "Please define TEMP | TMP | TMPDIR.\n");
    return (100);
  }

  for(p = tmp; *p; p++) {
    if(isknj(*p)) {
      p++; continue;
    }
    if(*p == '\\') *p = '/';
  }

  i = strlen(tmp);
  if(tmp[i-1] == '/') tmp[i-1] = '\0';

  for(i = 1; i < ac; i++) {
    if(!strncmp(av[i],"--l", 3) || !strncmp(av[i], "-l", 2)) {
      Logfile = 1;
      continue;
    }
    else if(!strncmp(av[i],"--c", 3) || !strncmp(av[i], "-c", 2)) {
      i++;
      if(i >= ac) {
        printf("Invalid argument.\n");
        exit (100);
      }
      strcpy(cnffile, av[i]);
      continue;
    }
    else if(!strncmp(av[i],"--eng", 5) || !strncmp(av[i], "-eng", 4)) {
      i++;
      if(i >= ac) {
        printf("Invalid argument.\n");
        exit (100);
      }
      strcpy(Enginename, av[i]);
      continue;
    }
    else if(!strncmp(av[i],"--f", 3) || !strncmp(av[i], "-f", 2)) {
      i++;
      if(i >= ac) {
        printf("Invalid argument.\n");
        exit (100);
      }
      strcpy(Destdir, av[i]);
      UserDestdir = 1;
      continue;
    }
    else if(!strncmp(av[i],"--a", 3) || !strncmp(av[i], "-a", 2)) {
      flag = 1;
      continue;
    }
    else if(!strncmp(av[i],"--m", 3) || !strncmp(av[i], "-m", 2)) {
      flag = 2;
      continue;
    }
    else if(!strncmp(av[i],"--byf", 5) || !strncmp(av[i], "-byf", 4)) {
      i++;
      if(i >= ac) {
        printf("Invalid argument.\n");
        exit (100);
      }
      flag = 3;
      strcpy(fmtname, av[i]);
      continue;
    }
    else if(!strncmp(av[i],"--byh", 5) || !strncmp(av[i], "-byh", 4)) {
      i++;
      if(i >= ac) {
        printf("Invalid argument.\n");
        exit (100);
      }
      flag = 4;
      strcpy(hyphenfile, av[i]);
      continue;
    }
    else if(!strncmp(av[i],"--s", 3) || !strncmp(av[i], "-s", 2)) {
      i++;
      if(i >= ac) {
        printf("Invalid argument.\n");
        exit (100);
      }
      flag = 5;
      strcpy(fmtname, av[i]);
      continue;
    }
    else if(!strncmp(av[i],"--v", 3) || !strncmp(av[i], "-v", 2)) {
      revision();
      return 0;
    }
    else if(!strncmp(av[i],"--h", 3) || !strncmp(av[i], "-h", 2)) {
      usage();
      return 0;
    }
    else {
      printf("%s: Invalid argument.\n\n", av[0]);
      usage();
      return 100;
    }
  }

  if(flag == 0) {
    usage();
    return 100;
  }


  if(!cnffile[0]) strcpy(cnffile, DEFAULTCNF);
  cnfname = kpse_find_file(cnffile, kpse_web2c_format, 0);
  if(!cnfname) {
    printf("Failed to find cnffile %s.\n", cnffile);
    exit (100);
  }

  in = fopen(cnfname, "r");
  free(cnfname);
  if(!in) {
    printf("Failed to open %s.\n", cnffile);
    exit (100);
  }

  for(i=0; i < MAXFMT; i++) {
    K[i].format = (char *)malloc(SIXTY4);
    K[i].engine = (char *)malloc(SIXTY4);
    K[i].hyphen = (char *)malloc(SIXTY4);
    K[i].args = (char *)malloc(SLEN);
    Exefile[i] = (char *)malloc(SIXTY4);
  }

  i = 0;
  while(fgets(Buff, BLEN, in)) {
    if(Buff[0] == '#' ||
       Buff[0] == '\n' ||
       Buff[0] == 0x25)
      continue;
    p = strtok(Buff, " \t");
    if(p)
      strcpy(K[i].format, p);
    else
      K[i].format[0] = '\0';
    p = strtok(NULL, " \t");
    if(p)
      strcpy(K[i].engine, p);
    else
      K[i].engine[0] = '\0';
    p = strtok(NULL, " \t");
    if(p)
      strcpy(K[i].hyphen, p);
    else
      K[i].hyphen[0] = '\0';
    p = strtok(NULL, "\n");
    if(p) {
      while(*p == ' ' || *p == '\t')
        p++;
      j = strlen(p);
      if(*(p+j-1) == '\n')
        *(p+j-1) = '\0';
      strcpy(K[i].args, p);
    }
    else
      K[i].args[0] = '\0';

    if(!K[i].format[0] ||
       !K[i].engine[0] ||
       !K[i].hyphen[0] ||
       !K[i].args) {
      printf("Invalid line in %s.\n", cnffile);
      freeK();
      return (100);
    }
    i++;
    if(i > MAXFMT) {
      printf("Too many lines in %s.\n", cnffile);
      freeK();
      return (100);
    }
  }

  Fmtnum = i;
  fclose(in);

  j = 0;
  if(flag == 5) {
    for(i = 0; i < Fmtnum; i++) {
      if(!stricmp(K[i].format, fmtname)) {
        show_hyphen(K[i].format, K[i].hyphen);
        j++;
      }
    }
    if(j == 0)
      printf("argument of --showhyphen must be a format name.\n");
    freeK();
    return 1;
  }

  if(UserDestdir == 0) {
    p = kpse_var_value("TEXMFMAIN");
    if(!p) {
      printf("TEXMFMAIN not defined.\n");
      freeK();
      return 100;
    }
    i = strlen(p);
    strcpy(Destdir, p);
    if(p[i-1] != '/' && p[i-1] != '\\') strcat(Destdir, "/");
    strcat(Destdir, "web2c");
  }

  for(p = Destdir; *p ; p++) {
    if(isknj(*p)) {
      p++; continue;
    }
    if(*p == '\\') *p = '/';
  }

  i = strlen(Destdir);
  if(Destdir[i-1] != '/') strcat(Destdir, "/");

  p = _getcwd(Currdir, BLEN);
  if(p) {
    for(p = Currdir; *p ; p++) {
      if(isknj(*p)) {
        p++; continue;
      }
      if(*p == '\\') *p = '/';
    }
    i = strlen(Currdir);
    if(Currdir[i-1] == '/') Currdir[i-1] = '\0';
    strcpy(kpsedot, "KPSE_DOT=.;");
    strcat(kpsedot, Currdir);
    _putenv(kpsedot);
  }

  cdrive = _getdrive();
  if(tmp[1] == ':') {
    tdrive = tolower(*tmp) -'a' + 1;
    _chdrive(tdrive);
  }
  _chdir(tmp);

  j = 0;
  if(flag == 4) {
    for(i = 0; i < Fmtnum; i++) {
      if(!stricmp(K[i].hyphen, hyphenfile)) {
        do_initex(K[i].format, K[i].engine, K[i].args);
        j++;
      }
    }
    if(j == 0)
      printf("hyphen pattern %s not written in %s.\n",hyphenfile,cnffile);
  }
  else if(flag == 3) {
    for(i = 0; i < Fmtnum; i++) {
      if(Enginename[0]) {
	if(!stricmp(Enginename, "metafont"))
	  strcpy(Realenginename, "mf-nowin");
	else if(!stricmp(Enginename, "metapost"))
	  strcpy(Realenginename, "mpost");
	else if(!stricmp(Enginename, "jmetapost"))
	  strcpy(Realenginename, "jmpost");
	else
	  strcpy(Realenginename, Enginename);
        if(!stricmp(K[i].format, fmtname) &&
           !stricmp(K[i].engine, Realenginename)) {
          do_initex(K[i].format, K[i].engine, K[i].args);
          j++;
        }
      }
      else {
        if(!stricmp(K[i].format, fmtname)) {
          do_initex(K[i].format, K[i].engine, K[i].args);
          j++;
        }
      }
    }
    if(j == 0) {
      if(Enginename[0])
        printf("format name %s with engine %s not written in %s.\n",
               fmtname, Realenginename, cnffile);
      else
        printf("format name %s not written in %s.\n", fmtname, cnffile);
    }
  }
  else if(flag == 2) {
    for(i = 0; i < Fmtnum; i++) {
      strcpy(Buff, Destdir);

      strcpy(enginesubdir, K[i].engine);
      if(!stricmp(enginesubdir, "mf-nowin"))
        strcpy(enginesubdir, "metafont");
      if(!stricmp(enginesubdir, "mf"))
        strcpy(enginesubdir, "metafont");
      if(!stricmp(enginesubdir, "mpost"))
        strcpy(enginesubdir, "metapost");
      if(!stricmp(enginesubdir, "jmpost"))
        strcpy(enginesubdir, "jmetapost");
      if(stricmp(enginesubdir, "nts"))
        strcat(Buff, enginesubdir);
      strcat(Buff, "/");

      strcat(Buff, K[i].format);
      if(!stricmp(K[i].engine, "nts"))
        strcat(Buff, ".nfmt");
      else if(!stricmp(K[i].engine, "mf"))
        strcat(Buff, ".base");
      else if(!stricmp(K[i].engine, "mf-nowin"))
        strcat(Buff, ".base");
      else if(!stricmp(K[i].engine, "mpost"))
        strcat(Buff, ".mem");
      else if(!stricmp(K[i].engine, "jmpost"))
        strcat(Buff, ".mem");
      else
        strcat(Buff, ".fmt");
      if(_access(Buff, 0) != 0)
        do_initex(K[i].format, K[i].engine, K[i].args);
      else
        printf("%s exists.\n", Buff);
    }
  }
  else if(flag == 1)
    do_all();

  _chdrive(cdrive);
  _chdir(Currdir);

/*
Check executable files. (ignore "Batch" or "Script" files (case 'x'))
*/
  if(Exenum) {
    printf("\n\nNow I check executable files...\n");
    printf("If some executable files do not exist, you must make them\n");
    printf("by hard link (Windows NT/2000/XP) or copying (Windows 95/98/Me).\n\n");

    for(i = 0; i < Exenum; i++) {
      if(testexe(Exefile[i], ".exe"))
        sprintf(Buff, "OK. %s.exe exists.", Exefile[i]);
      else if(testexe(Exefile[i], ".bat"))
        sprintf(Buff, "OK. %s.bat exists.", Exefile[i]);
      else if(testexe(Exefile[i], ".sh"))
        sprintf(Buff, "OK. %s.sh exists.", Exefile[i]);
      else
        sprintf(Buff, "I cannot find %s.", Exefile[i]);
      j = strlen(Buff);

      if((i+1) % 2) {
        for(k = j; k < 36; k++)
          Buff[k] = ' ';
        Buff[k] = '\0';
        printf("%s", Buff);
      }
      else {
        printf("%s", Buff);
        printf("\n");
      }
    }
    printf("\n");
  }
  freeK();
  return 0;
}
