/*
mktexlsr ( equivalent to the script )
Web2C 7.3.7 (2002/10/09 --ak)
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <malloc.h>
#include <kpathsea/kpathsea.h>
#include <kpathsea/dirent.h>
#include <windows.h>
#define TRANSFORM(x) ((unsigned)CharLower((LPTSTR)(BYTE)(x)))

#define  MAXTREE  16 /* Max number of texmf trees */

/* magic header */
#define HDL "%% ls-R -- maintained by mktexlsr; do not change this line.\n"

#define VARTEXFONTS "c:/var/tex/fonts/ls-R"

FILE *ls_R;

void search(char *name)
{
  DIR *dp;
  struct dirent *de;
  char   buff[256];
  char   *p;
  int    len;

  for(p = name; *p; p++) {
    if(isknj(*p)) {
      p++; continue;
    }
    if(*p == '\\') *p = '/';
  }

  if(dp = opendir(name)) {
    for(p=name; *p; p++) {
      if(isknj(*p)) {
        p++; continue;
      }
      *p = TRANSFORM(*p);
    }
    fprintf(ls_R, "\n%s:\n", name);
    while(de = readdir(dp)) {
      if((de->d_name[0] != '.')) {
        for(p=de->d_name; *p; p++) {
          if(isknj(*p)) {
            p++; continue;
          }
          *p = TRANSFORM(*p);
        }
        fprintf(ls_R, "%s\n", de->d_name);
      }
    }
    closedir(dp);
    dp = opendir(name);
    while(de = readdir(dp)) {
      if((de->d_name[0] != '.') && de->d_isdir) {
        len = strlen(name);
        strcpy(buff, name);
        if(name[len-1] != '/')
          strcat(buff, "/");
        strcat(buff, de->d_name);
        search(buff);
      }
    }
    closedir(dp);
    return;
  }
  else return;
}

int main(int ac, char **av)
{
  char *texmfdbs ;
  int cdrive, tdrive;
  char ls_R_name[256];
  int len, i, numtree;
  char *progname;
  char *pathbuff[MAXTREE];
  char *p, *q;

  getlongname(av[0]);
  progname = av[0];
  kpse_set_progname(progname);

  for(i = 0; i < MAXTREE; i++) {
    pathbuff[i] = (char *)malloc(128);
    if(!pathbuff[i]) {
      fprintf(stderr, "Memory allocation error.\n");
      exit(100);
    }
  }

  if(!(p = kpse_var_value("TEXMFDBS"))) {
    fprintf(stderr, "TEXMFDBS is not defined in texmf.cnf.\n");
    exit (100);
  }

  texmfdbs = kpse_brace_expand(p);
  free(p);

  for(i=0 ; (i < MAXTREE) && *texmfdbs ; i++) {
    p = kstrchr(texmfdbs, ';');
    if(!p) {
      strcpy(pathbuff[i], texmfdbs);
      q = pathbuff[i];
      if(*q == '!' && *(q+1) == '!')
        q += 2;
      strcpy(pathbuff[i], q);
      i++;
      break;
    }
    *p = '\0';
    strcpy(pathbuff[i], texmfdbs);
    q = pathbuff[i];
    if(*q == '!' && *(q+1) == '!')
      q += 2;
    strcpy(pathbuff[i], q);
    p++;
    texmfdbs = p;
  }

  numtree = i;
  
  for(i = 0; i < numtree; i++) {
    strcpy(ls_R_name, pathbuff[i]);
    len = strlen(ls_R_name);
    if(ls_R_name[len-1] != '/') strcat(ls_R_name, "/");
    strcat(ls_R_name, "ls-R");

    ls_R = fopen(ls_R_name, "wb");
    if(!ls_R) {
      fprintf(stderr, "Cannot open %s to write.\n", ls_R_name);
      if(!stricmp(ls_R_name, VARTEXFONTS))
        fprintf(stderr, "       (Don't mind this message.)\n");
      continue;
    }

    cdrive = _getdrive();

    if(ls_R_name[1] == ':') {
      tdrive = tolower(ls_R_name[0]) - 'a' + 1;
      _chdrive(tdrive);
    }

    _chdir(pathbuff[i]);
  
    fprintf(stderr, "%s: Updating %s...\n", progname, ls_R_name);
    fprintf(ls_R, HDL);
    search("./");

    fclose(ls_R);
    fprintf(stderr, "%s: Updated %s.\n", progname, ls_R_name);
    _chdrive(cdrive);
  }

  fprintf(stderr, "%s: Done.\n", progname);
  
  for(i = 0; i < MAXTREE; i++) {
    free(pathbuff[i]);
  }

  return 0;
}
