/*
 *  KANJI Code conversion routines.
 */

#ifndef PTX_KANJI_H
#define PTX_KANJI_H

#include <sys/types.h>
#include <ptxconfig.h>
#include <protos.h>
#include <stdio.h>

#ifdef DEFAULT_KANJI

#define KANJI_OPTS "{jis|euc|sjis|utf8}"

/* OBSOLETE: get/set Kanji encode */
extern PTXDLL int get_kanji_enc P1H(void);
extern PTXDLL void set_kanji_enc P1H(int);
#define getkanjienc get_kanji_enc
#define setkanjienc set_kanji_enc

/* get/set Kanji encode name as string */
extern PTXDLL char * get_kanji_enc_string P1H(void);
extern PTXDLL int set_kanji_enc_string P1H(char *);
#define getkanjiencstring get_kanji_enc_string
#define setkanjiencstring set_kanji_enc_string

/* decide if internal Kanji encode is SJIS or not */
extern PTXDLL int is_internalSJIS P1H(void);
#define isinternalSJIS is_internalSJIS

/* set is_internalSJIS() always false (for jbibtex) */
extern PTXDLL void set_internal_euc_only P1H(void);

/* check Kanji range */
extern PTXDLL int iskanji1 P1H(int);
extern PTXDLL int iskanji2 P1H(int);

/* internal Kanji cod (EUC or SJIS) to/from JIS Kanji code conversion */
extern PTXDLL int toJIS P1H(int);
extern PTXDLL int fromJIS P1H(int);

/* EUC/SJIS/KUTN to internal Kanji code (EUC or SJIS) conversion */
extern PTXDLL int fromEUC P1H(int);
extern PTXDLL int fromSJIS P1H(int);
extern PTXDLL int fromKUTEN P1H(int);


/* put char with Kanji code conversion */
extern PTXDLL int putc2 P2H(int, FILE *);

/* input line with Kanji code conversion */
extern PTXDLL int
input_line2 P5H(FILE *, char *, long, long, int*);
#define inputline2(fp,buff,pos,size) (input_line2(fp,buff,(pos)+1,size,NULL)-1)

#endif /* DEFAULT_KANJI */
#endif /* PTX_KANJI_H */
