/*
 *  KANJI Code conversion routines.
 */

#ifndef PTX_KANJICNV_H
#define PTX_KANJICNV_H

#include <sys/types.h>
#include <protos.h>

#ifdef DEFAULT_KANJI

#define HI(x)     ((((int)(x)) >> 8) & 0xff)
#define LO(x)     ( ((int)(x))       & 0xff)
#define HILO(x,y) ((LO(x) << 8) | LO(y))

extern PTXDLL int isEUCkanji1 P1H(int);
extern PTXDLL int isEUCkanji2 P1H(int);

extern PTXDLL int isSJISkanji1 P1H(int);
extern PTXDLL int isSJISkanji2 P1H(int);

/* EUC <=> JIS X 0208 code conversion */
extern PTXDLL int EUCtoJIS P1H(int);
extern PTXDLL int JIStoEUC P1H(int);

/* Shift JIS <=> JIS Kanji code conversion */
extern PTXDLL int SJIStoJIS P1H(int);
extern PTXDLL int JIStoSJIS P1H(int);

/* Shift JIS <=> EUC Kanji code conversion */
extern PTXDLL int SJIStoEUC P1H(int);
extern PTXDLL int EUCtoSJIS P1H(int);

/* KUTEN => JIS kanji code conversion */
extern PTXDLL int KUTENtoJIS P1H(int);

#endif /* DEFAULT_KANJI */
#endif /* PTX_KANJICNV_H */
